%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global pypi_name networking-bigswitch
%global module_name networking_bigswitch
%global rpm_prefix openstack-neutron-bigswitch
%global docpath doc/build/html
%global lib_dir %{buildroot}%{python2_sitelib}/%{module_name}/plugins/bigswitch

Name:           python-%{pypi_name}
Epoch:          2
Version:        10.0.6
Release:        1%{?dist}
Summary:        Big Switch Networks neutron plugin for OpenStack Networking
License:        ASL 2.0
URL:            https://pypi.python.org/pypi/%{pypi_name}
Source0:        https://pypi.io/packages/source/n/%{pypi_name}/%{pypi_name}-%{upstream_version}.tar.gz
Source1:        neutron-bsn-agent.service
Source2:        neutron-bsn-lldp.service
Provides: python2-networking-bigswitch = %{epoch}:%{version}-%{release}
BuildArch:      noarch

#
#patches_ignore=DROP-IN-RPM
#patches_base=10.0.6
Patch0001: 0001-Resolve-setup.cfg-munging-by-setuptools.patch
Patch0002: 0002-fix-version-conflict-for-babel.patch
Patch0003: 0003-OSP-76-perform-delete-on-secondary-network-regardles.patch
Patch0004: 0004-BVS-8259-skip-upstream-method-override.patch
Patch0005: 0005-OSP-29-allow-LACP-convergence-when-only-one-link-is-.patch
Patch0006: 0006-OSP-72-allow-subnets-without-name-instead-of-raising.patch
Patch0007: 0007-OSP-68-handle-VM-detach-operation.patch
Patch0008: 0008-OSP-72-cleanup-popping-of-subnet-name.patch
Patch0009: 0009-OSP-64-in-case-of-sriov-do-not-get-interface-list-fr.patch
Patch0010: 0010-BVS-5916-special-character-error-message-update.patch
Patch0011: 0011-cleanup-move-function-call-debug-log-msg-into-decora.patch
Patch0012: 0012-OSP-36-update-translation-to-one-from-plugin.patch
Patch0013: 0013-OSP-103-fix-testpath-with-special-char-in-tenant-seg.patch
Patch0014: 0014-bump-epoch.patch
Patch0015: 0015-use-context_manager-for-more-transactions.patch
Patch0016: 0016-BVS-7488-set-Jumbo-MTU-to-9000.patch
Patch0017: 0017-Checks-and-creates-bsn_tables-if-not-already-created.patch

BuildRequires:  python-devel
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
BuildRequires:  systemd-units

Requires:       openstack-neutron-common >= 1:7.0.0
Requires:       python-pbr >= 0.10.8
Requires:       python-oslo-log >= 1.0.0
Requires:       python-oslo-config >= 2:1.9.3
Requires:       python-oslo-utils >= 1.4.0
Requires:       python-oslo-messaging >= 1.8.0
Requires:       python-oslo-serialization >= 1.4.0

Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd

%description
This package contains Big Switch Networks
neutron plugins and agents

%package -n %{rpm_prefix}-agent
Summary:        Neutron Big Switch Networks agent
Requires:       python-%{pypi_name} = %{epoch}:%{version}-%{release}

%description -n %{rpm_prefix}-agent
This package contains the Big Switch Networks
neutron agent for security groups.

%package -n %{rpm_prefix}-lldp
Summary:        Neutron Big Switch Networks LLDP service
Requires:       python-%{pypi_name} = %{epoch}:%{version}-%{release}

%description -n %{rpm_prefix}-lldp
This package contains the Big Switch Networks neutron LLDP agent.

%package doc
Summary:        Neutron Big Switch Networks plugin documentation

%description doc
This package contains the documentation for
Big Switch Networks neutron plugins.

%prep
%setup -q -n %{pypi_name}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1

%build
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py build
%{__python2} setup.py build_sphinx
rm %{docpath}/.buildinfo

%install
%{__python2} setup.py install --skip-build --root %{buildroot}
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/neutron-bsn-agent.service
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/neutron-bsn-lldp.service
mkdir -p %{buildroot}/%{_sysconfdir}/neutron/conf.d/neutron-bsn-agent
mkdir -p %{lib_dir}/tests
for lib in %{lib_dir}/version.py %{lib_dir}/tests/test_server.py; do
    sed '1{\@^#!/usr/bin/env python@d}' $lib > $lib.new &&
    touch -r $lib $lib.new &&
    mv $lib.new $lib
done

# moving the file seems to break setup.py install rhbz#1455141
install -p -D -m 664 networking_bigswitch/plugins/bigswitch/db/migration/alembic_migrations/versions/f774eae87144_rename_tenant_to_project.py %{buildroot}/usr/lib/python2.7/site-packages/networking_bigswitch/plugins/bigswitch/db/migration/alembic_migrations/versions/

%files
%license LICENSE
%{python2_sitelib}/%{module_name}
%{python2_sitelib}/*.egg-info

%config %{_sysconfdir}/neutron/policy.d/bsn_plugin_policy.json

%files -n %{rpm_prefix}-agent
%license LICENSE
%{_unitdir}/neutron-bsn-agent.service
%{_bindir}/neutron-bsn-agent
%dir %{_sysconfdir}/neutron/conf.d/neutron-bsn-agent

%files -n %{rpm_prefix}-lldp
%license LICENSE
%{_unitdir}/neutron-bsn-lldp.service
%{_bindir}/bsnlldp

%files doc
%license LICENSE
%doc README.rst
%doc %{docpath}

%post
%systemd_post neutron-bsn-agent.service
%systemd_post neutron-bsn-lldp.service

%preun
%systemd_preun neutron-bsn-agent.service
%systemd_preun neutron-bsn-lldp.service

%postun
%systemd_postun_with_restart neutron-bsn-agent.service
%systemd_postun_with_restart neutron-bsn-lldp.service

%changelog
* Wed Jun 28 2017 Mike Burns <mburns@redhat.com> 2:10.0.6-1
- Update to 10.0.6

* Tue May 30 2017 Mike Burns <mburns@redhat.com> 2:10.0.4-7
- ensure the file from rhbz#1455141 is actually available

* Fri May 26 2017 Steve Linabery <slinaber@redhat.com> 2:10.0.4-6
- OSP-21: fix dangling move of files (rhbz#1455141)

* Mon May 22 2017 Steve Linabery <slinaber@redhat.com> 2:10.0.4-5
- Checks and creates bsn_tables if not already created

* Thu Apr 27 2017 Mike Burns <mburns@redhat.com> 2:10.0.4-4
- readd python2 provides

* Fri Apr 21 2017 Mike Burns <mburns@redhat.com> 2:10.0.4-2
- Update epoch to make rpm updates work rhbz#1444142

* Mon Apr 17 2017 Steve Linabery <slinaber@redhat.com> 1:10.0.4-2
- BVS-5916: handle special characters in object names
- OSP-43: dont support pci passthrough vnic type

* Wed Apr 12 2017 Steve Linabery <slinaber@redhat.com> 1:10.0.4-1
- Update to 10.0.4

* Mon Apr 03 2017 Jon Schlueter <jschluet@redhat.com> 1:10.0.3-2
- BVS-5916: allow spaces in security group names
- BVS-7861: ignore description when syncing with controller

* Wed Mar 29 2017 Jon Schlueter <jschluet@redhat.com> 1:10.0.3-1
- Update to 10.0.3

* Wed Mar 22 2017 Mike Burns <mburns@redhat.com> 1:10.0.1-2
- Merge "OSP-47: ensure tenant_id is changed to project_id newton upwards" into stable/ocata
- OSP-47: ensure tenant_id is changed to project_id newton upwards
- ensure all keystone conf is read from config file

